// Rendering times
// Note 1:- antialias quick = 4min
//          antialias adaptive = 55min (due to metal textures suppose)
//          Vividw 2.a 18  486/66 under DR_DOS
// Note 2:- anitalias adaptive = 3hr 44min (with lsrsprk.vo included) :-(
//          Looks great tho'. :-)
//          Vividw 2.a 18  486/66 under DR_DOS
// Note 3:- Lsrsprk.bas at end of this file

//ͻ
//         LSRLOGO.V = Spun Chrome Vivid Logo Zapped By Laser Beam         
//                      May 23rd 1993  Martin Higgs                        
//ͼ

//------1---------2---------3---------4---------5---------6---------7---------8
// Modified to POV-Ray format by Colin Fleming, cj_fleming@btinternet.com

#version 3.6;

global_settings {
	assumed_gamma 2.2
	max_trace_level 50
	ambient_light rgb 0.1
	photons {
		spacing 0.0015               
	}
}

#include "colors.inc"
#include "textures.inc"
#include "metals.inc"
#include "glass.inc"

camera {
	location <-7.5, -9, 6>
	look_at <1.75, 0, 1>
	up z
	sky z
	angle 25
	right x*4/3
}

background { color rgb <0.9, 0.9, 0> }

//......light sources
light_source { <-3, -0.5, 4> color rgb 0.10 }
light_source { <4, -2, 4> color rgb 0.10 }
light_source { <5, -9, 1> SkyBlue }

//.......at impact point of laser beam
light_source {
	x*1.25
	color Red*50
	cylinder
	falloff 0
	radius 0.3
}

//.......glow at impact point
sphere { x*1.25, 0.2 //fuzz 0.2 }
	pigment { Pink*5 filter 0.999 transmit 0.999 }
	//pigment { Red*5 filter 0.999 transmit 0.999 }
	//finish { ambient 0.8 }
	//hollow
	photons {
	    refraction on
	    reflection on
	}
}

// LSRSPRK.BAS
//......sparks from cones at impact point
union {
    #local RD = 1.5;
    #local PIE = 3.1415936;
    #local DD = 0.1;
    #local EE = 0.1;
    #for (DD, 0.1, 360, 18)
        #for (EE, 0.1, 360, 18)
            #local XX = sin(EE * PIE / 180) * RD * sin(DD * PIE / 180);
            #local YY = sin(EE * PIE / 180) * RD * cos(DD * PIE / 180);
            #local ZZ = (RD * RD) - (pow(XX, 2) + pow(YY, 2));
            #local ZZ = pow(ZZ, 0.5);
            #if (EE > 180)
				#declare ZZ = -ZZ;
			#end
            cone { <XX, YY, ZZ>, 0, 0, 0.01 }
            //#debug concat("cone { <",str(XX,0,3),", ",str(YY,0,3),", ",str(ZZ,0,3),">, 0, 0, 0.01 }\n" )
        #end
    #end
    translate x*1.25
    pigment { Red*5 filter 0.999 }//transmit 0.999 }
	finish { ambient 2 }
	photons {
	    refraction on
	    reflection on
	}
}

//ͻ
//                          Brushed Chrome Floor                           
//ͼ

// now a dented chrome floor!
disc {
	z*-0.02, z, 1000
	//clipped_by { sphere { x*1.25, 0.1 } }

	//texture { T_Copper_3E }
	texture { T_Chrome_5A }
	normal { dents 1 scale 4/95 }
}

//ͻ
//                               Laser Beam                                
//ͼ

union {
	cone { <-7.5, -11, 7.5>, 0.00003, x*1.25, 0.015 }
	cone { <-7.5,  11, 7.5>, 0.00003, x*1.25, 0.015 }
	pigment { Red*10 transmit 0.9 } //transmit 0.7 }
	finish { ambient 2 }
    hollow
	photons {
	    refraction on
	    reflection on
	}
}

//ͻ
//                       Bright Spun Chrome Vivid Logo                     
//ͼ

union { // Vivid Logo

	//ͻ
	//                          V taken from  MG_V.VO                          
	//                            1993 Martin Higgs                            
	//ͼ
	//Note:- This does not seem to clip the "top groove" correctly, looks OK to
	//       me,but then..

	union {
		cone { 0, 0, z*1.5, 0.75
			clipped_by {
				cylinder { <0, -0.75, 1.5>, <0, 0.75, 1.5>, 0.4 inverse}
			}
		}
		cylinder {
			<0, -0.75, 1.5>, <0, 0.75, 1.5>, 0.4
			clipped_by {
				cone { 0, 0, z*1.5, 0.75 }
			}
		}
		disc {
			z*1.5, z, 0.75
			clipped_by {
				cylinder { <0, -0.75, 1.5>, <0, 0.75, 1.5>, 0.4 inverse}
			}
		}
		translate x*-0.15
		scale 1.33333
	}

	//ͻ
	//                          I taken from  MG_I.VO                          
	//                            1993 Martin Higgs                            
	//ͼ

	union {
		cone {
			0, 0, z*1.5, 0.3
			clipped_by {
				sphere { x*1.25, 0.3 inverse }
			}
		}
		disc {
			z*1.5, z, 0.3
		}
		sphere {
			z*1.75, 0.25
		}
		translate x*1.25
	}	

	//ͻ
	//                          V taken from  MG_V.VO                          
	//                            1993 Martin Higgs                            
	//ͼ

	union {
		cone { 
			0, 0, z*1.5, 0.75 
			clipped_by { 
				cylinder { <0, -0.75, 1.5>, <0, 0.75, 1.5>, 0.4 inverse }
			}
		}
		cylinder { 
			<0, -0.75, 1.5>, <0, 0.75, 1.5>, 0.4 
			clipped_by { 
				cone { 0, 0, z*1.5, 0.75 }
			}
		}
		disc { 
			z*1.5, z, 0.75
			clipped_by { 
				cylinder { <0, -0.75, 1.5>, <0, 0.75, 1.5>, 0.4 inverse }
			}
		}
		translate x*2.5
	}

	//ͻ
	//                          I taken from  MG_I.VO                          
	//                            1993 Martin Higgs                            
	//ͼ

	union {
		cone {
			0, 0, z*1.5, 0.3
			clipped_by {
				sphere { x*1.25, 0.3 inverse }
			}
		}
		disc {
			z*1.5, z, 0.3
		}
		sphere {
			z*1.75, 0.25
		}
		translate x*3.75
	}

	//ͻ
	//                          D taken from  MG_D.VO                          
	//                            1993 Martin Higgs                            
	//ͼ

	union {
		sphere { 
			z*0.75, 0.75
			clipped_by {
				cylinder { <0, -0.75, 1>, <0, 0.75, 1>, 0.4 inverse  }
			}
		}
		cylinder { 
			<0, -0.75, 1>, <0, 0.75, 1>, 0.4 
			clipped_by {
				sphere { z*0.75, 0.75 }
			}
		}
		cone { 
			x*0.75, 0, <0.75, 0, 2>, 0.3 
		}
		disc { 
			<0.75, 0, 2>, z, 0.3
		}
		translate x*4.9
	}

	//texture { T_Copper_3E }
	texture { T_Chrome_5A }
	normal { dents 1 scale <4/250, 1, 1> rotate <90, 90, -90> }
	photons {
		//target
		reflection on
		//collect off
	}
    
} //end union
